*-------------------------------------------------------
*	diskdiag.s	v0.10
*			1996/05/31 by K.Hayashi
*-------------------------------------------------------

		.include	iocscall.mac
		.include	doscall.mac

READ_SIZE:	equ	4096

PRINT		.macro	mes
		pea	mes
		DOS	__PRINT
		addq.w	#4,sp
		.endm

		.offset	0
old_trap14:	ds.l	1
data_buf:	ds.b	READ_SIZE
worksize:

		.text
		.even
start::
		addq.w	#1,a2
		lea	work(pc),a6		*a6 : work pointer

		*----------------------*	*vector set
		move.w	#$2E,-(sp)
		DOS	__INTVCG
		addq.w	#2,sp
		move.l	d0,old_trap14(a6)

		pea	TRAP14(pc)
		move.w	#$2E,-(sp)
		DOS	__INTVCS
		addq.w	#6,sp
		*----------------------*

		clr.w	-(sp)
		pea	(a2)			*a2 : filename (command line)
		DOS	__OPEN
		addq.w	#6,sp
		tst.l	d0
		bmi	open_error
		move.w	d0,d2

		clr.l	d1			*d1 : file size
read_loop::
		move.l	#READ_SIZE,-(sp)
		pea	data_buf(a6)
		move.w	d2,-(sp)		*d2 : file handle
		DOS	__READ
		lea	10(sp),sp

		tst.l	d0
		bmi	read_error
		add.l	d0,d1
		cmpi.l	#READ_SIZE,d0
		beq	read_loop

read_exit::
		move.w	d2,-(sp)
		DOS	__CLOSE
		addq.w	#2,sp

		pea	mes_ok(pc)
exit::		DOS	__PRINT
		addq.w	#4,sp

		*----------------------*	*vector reset
		move.l	old_trap14(a6),-(sp)
		move.w	#$2E,-(sp)
		DOS	__INTVCS
		addq.w	#6,sp
		*----------------------*

		DOS	__EXIT

*-----------------------------------------------*
open_error::
		pea	mes_open_error(pc)
		bra	exit

read_error::
		pea	mes_read_error(pc)
		bra	exit

*-----------------------------------------------*
*	TRAP14 routine
*-----------------------------------------------*
TRAP14::
		movem.l	d0-d6/a0-a6,-(sp)

		cmp.w	#$1000,d7
		bcs	TRAP14_etc
		cmp.w	#$8000,d7
		bcc	TRAP14_etc
		cmp.b	#$05,d7
		beq	TRAP14_disk
TRAP14_etc::
		PRINT	mes_etc_error(pc)
		bra	@f
TRAP14_disk::
		PRINT	mes_read_serious(pc)
@@:		moveq	#0,d7				*Abort
		IOCS	__ABORTJOB

		movem.l	(sp)+,d0-d6/a0-a6
		rte

		.data
		.even

mes_ok::
		dc.b	"0",0
mes_read_serious::
		dc.b	"1",0
mes_open_error::
		dc.b	"-1",0
mes_read_error::
		dc.b	"-2",0
mes_etc_error::
		dc.b	"-3",0

		.bss
		.even

work::		ds.b	worksize

		.end
