#!/usr/local/bin/jperl
#
#	disk diagnostic program v0.10
#					1996/5/31 by K.Hayashi
#
$subprog = "diagsub.r";
$verbose_f = 0;
$recursive_f = 0;

if ($#ARGV >= 0) {
	if ($ARGV[0] =~ /^-[rR]$/) {
		$recursive_f++;
		shift(@ARGV);
	}
	if ($ARGV[0] =~ /^-[vV]$/ ) {
		$verbose_f++;
		shift(@ARGV);
	}
	if ($ARGV[0] =~ /^-[hH]$/ ) {
		print "Disk diagnostic program v0.10 by K.Hayashi\n";
		print "usage: diskdiag [-r][-v][-h] directory ..\n";
		print "\t-r\tRecursive\n";
		print "\t-v\tVerbose\n";
		print "\t-h\tHelp\n";
		exit;
	}
}
if ($#ARGV >= 0) {
	for($i = 0;$i <= $#ARGV;$i++) {
		&diag($ARGV[$i]);
	}
}
else {
	&diag(".");
}

sub diag {
	local($cur) = $_[0];
	local($len,$path,$DD);

	$DD = $cur;
	opendir($DD,$cur);

	while($dir = readdir($DD)) {

		if ($dir !~ /^\.\.?$/) {

			$path = $cur."/".$dir;
			$path =~ s/\/+/\//g;

			if (((lstat($path))[2] & 16) == 0) {
				open(FD,"$subprog ".$path."|");
				$code = <FD>;
				close(FD);

				if ($verbose_f) {
					print "checking $path \n";
				}

				if ($code == 1) {
					if ($verbose_f) {
						print "Found    $path \n";
					}
					else {
						print $path,"\n";
					}
				}
				if ($code < 0) {
					print "Error    $path :err=$code";
				}
			}
			elsif ($recursive_f) {
				&diag($path);
			}
		}
	}
	closedir($DD);
}
